// Code generated by generate-tl-files; DO NOT EDIT.

package telegram

type AccessPointRule struct {
	PhonePrefixRules string
	DcID             int32
	Ips              []IpPort
}

func (*AccessPointRule) CRC() uint32 {
	return 0x4679b65f
}

type AccountAuthorizationForm struct {
	RequiredTypes    []SecureRequiredType
	Values           []*SecureValue
	Errors           []SecureValueError
	Users            []User
	PrivacyPolicyURL string `tl:"flag:0"`
}

func (*AccountAuthorizationForm) CRC() uint32 {
	return 0xad2e1cd8
}

func (*AccountAuthorizationForm) FlagIndex() int {
	return 0
}

type AccountAuthorizations struct {
	Authorizations []*Authorization
}

func (*AccountAuthorizations) CRC() uint32 {
	return 0x1250abde
}

type AccountAutoDownloadSettings struct {
	Low    *AutoDownloadSettings
	Medium *AutoDownloadSettings
	High   *AutoDownloadSettings
}

func (*AccountAutoDownloadSettings) CRC() uint32 {
	return 0x63cacf26
}

type AccountContentSettings struct {
	SensitiveEnabled   bool `tl:"flag:0,encoded_in_bitflags"`
	SensitiveCanChange bool `tl:"flag:1,encoded_in_bitflags"`
}

func (*AccountContentSettings) CRC() uint32 {
	return 0x57e28221
}

func (*AccountContentSettings) FlagIndex() int {
	return 0
}

type AccountPassword struct {
	HasRecovery             bool            `tl:"flag:0,encoded_in_bitflags"`
	HasSecureValues         bool            `tl:"flag:1,encoded_in_bitflags"`
	HasPassword             bool            `tl:"flag:2,encoded_in_bitflags"`
	CurrentAlgo             PasswordKdfAlgo `tl:"flag:2"`
	SRPB                    []byte          `tl:"flag:2"`
	SRPID                   int64           `tl:"flag:2"`
	Hint                    string          `tl:"flag:3"`
	EmailUnconfirmedPattern string          `tl:"flag:4"`
	NewAlgo                 PasswordKdfAlgo
	NewSecureAlgo           SecurePasswordKdfAlgo
	SecureRandom            []byte
}

func (*AccountPassword) CRC() uint32 {
	return 0xad2641f8
}

func (*AccountPassword) FlagIndex() int {
	return 0
}

type AccountPasswordInputSettings struct {
	NewAlgo           PasswordKdfAlgo       `tl:"flag:0"`
	NewPasswordHash   []byte                `tl:"flag:0"`
	Hint              string                `tl:"flag:0"`
	Email             string                `tl:"flag:1"`
	NewSecureSettings *SecureSecretSettings `tl:"flag:2"`
}

func (*AccountPasswordInputSettings) CRC() uint32 {
	return 0xc23727c9
}

func (*AccountPasswordInputSettings) FlagIndex() int {
	return 0
}

type AccountPasswordSettings struct {
	Email          string                `tl:"flag:0"`
	SecureSettings *SecureSecretSettings `tl:"flag:1"`
}

func (*AccountPasswordSettings) CRC() uint32 {
	return 0x9a5c33e5
}

func (*AccountPasswordSettings) FlagIndex() int {
	return 0
}

type AccountPrivacyRules struct {
	Rules []PrivacyRule
	Chats []Chat
	Users []User
}

func (*AccountPrivacyRules) CRC() uint32 {
	return 0x50a04e45
}

type AccountSentEmailCode struct {
	EmailPattern string
	Length       int32
}

func (*AccountSentEmailCode) CRC() uint32 {
	return 0x811f854f
}

type AccountTakeout struct {
	ID int64
}

func (*AccountTakeout) CRC() uint32 {
	return 0x4dba4501
}

type AccountTmpPassword struct {
	TmpPassword []byte
	ValidUntil  int32
}

func (*AccountTmpPassword) CRC() uint32 {
	return 0xdb64fd34
}

type AccountWebAuthorizations struct {
	Authorizations []*WebAuthorization
	Users          []User
}

func (*AccountWebAuthorizations) CRC() uint32 {
	return 0xed56c9fc
}

type AccountDaysTtl struct {
	Days int32
}

func (*AccountDaysTtl) CRC() uint32 {
	return 0xb8d0afdf
}

type AuthExportedAuthorization struct {
	ID    int32
	Bytes []byte
}

func (*AuthExportedAuthorization) CRC() uint32 {
	return 0xdf969c2d
}

type AuthPasswordRecovery struct {
	EmailPattern string
}

func (*AuthPasswordRecovery) CRC() uint32 {
	return 0x137948a5
}

type AuthSentCode struct {
	Type          AuthSentCodeType
	PhoneCodeHash string
	NextType      AuthCodeType `tl:"flag:1"`
	Timeout       int32        `tl:"flag:2"`
}

func (*AuthSentCode) CRC() uint32 {
	return 0x5e002502
}

func (*AuthSentCode) FlagIndex() int {
	return 0
}

type Authorization struct {
	Current         bool `tl:"flag:0,encoded_in_bitflags"`
	OfficialApp     bool `tl:"flag:1,encoded_in_bitflags"`
	PasswordPending bool `tl:"flag:2,encoded_in_bitflags"`
	Hash            int64
	DeviceModel     string
	Platform        string
	SystemVersion   string
	APIID           int32
	AppName         string
	AppVersion      string
	DateCreated     int32
	DateActive      int32
	Ip              string
	Country         string
	Region          string
}

func (*Authorization) CRC() uint32 {
	return 0xad01d61d
}

func (*Authorization) FlagIndex() int {
	return 0
}

type AutoDownloadSettings struct {
	Disabled              bool `tl:"flag:0,encoded_in_bitflags"`
	VideoPreloadLarge     bool `tl:"flag:1,encoded_in_bitflags"`
	AudioPreloadNext      bool `tl:"flag:2,encoded_in_bitflags"`
	PhonecallsLessData    bool `tl:"flag:3,encoded_in_bitflags"`
	PhotoSizeMax          int32
	VideoSizeMax          int32
	FileSizeMax           int32
	VideoUploadMaxbitrate int32
}

func (*AutoDownloadSettings) CRC() uint32 {
	return 0xe04232f3
}

func (*AutoDownloadSettings) FlagIndex() int {
	return 0
}

type BankCardOpenURL struct {
	URL  string
	Name string
}

func (*BankCardOpenURL) CRC() uint32 {
	return 0xf568028a
}

type BotCommand struct {
	Command     string
	Description string
}

func (*BotCommand) CRC() uint32 {
	return 0xc27ac8c7
}

type BotInfo struct {
	UserID      int32
	Description string
	Commands    []*BotCommand
}

func (*BotInfo) CRC() uint32 {
	return 0x98e81d3a
}

type CdnConfig struct {
	PublicKeys []*CdnPublicKey
}

func (*CdnConfig) CRC() uint32 {
	return 0x5725e40a
}

type CdnPublicKey struct {
	DcID      int32
	PublicKey string
}

func (*CdnPublicKey) CRC() uint32 {
	return 0xc982eaba
}

type ChannelAdminLogEvent struct {
	ID     int64
	Date   int32
	UserID int32
	Action ChannelAdminLogEventAction
}

func (*ChannelAdminLogEvent) CRC() uint32 {
	return 0x3b5a3e40
}

type ChannelAdminLogEventsFilter struct {
	Join     bool `tl:"flag:0,encoded_in_bitflags"`
	Leave    bool `tl:"flag:1,encoded_in_bitflags"`
	Invite   bool `tl:"flag:2,encoded_in_bitflags"`
	Ban      bool `tl:"flag:3,encoded_in_bitflags"`
	Unban    bool `tl:"flag:4,encoded_in_bitflags"`
	Kick     bool `tl:"flag:5,encoded_in_bitflags"`
	Unkick   bool `tl:"flag:6,encoded_in_bitflags"`
	Promote  bool `tl:"flag:7,encoded_in_bitflags"`
	Demote   bool `tl:"flag:8,encoded_in_bitflags"`
	Info     bool `tl:"flag:9,encoded_in_bitflags"`
	Settings bool `tl:"flag:10,encoded_in_bitflags"`
	Pinned   bool `tl:"flag:11,encoded_in_bitflags"`
	Edit     bool `tl:"flag:12,encoded_in_bitflags"`
	Delete   bool `tl:"flag:13,encoded_in_bitflags"`
}

func (*ChannelAdminLogEventsFilter) CRC() uint32 {
	return 0xea107ae4
}

func (*ChannelAdminLogEventsFilter) FlagIndex() int {
	return 0
}

type ChannelsAdminLogResults struct {
	Events []*ChannelAdminLogEvent
	Chats  []Chat
	Users  []User
}

func (*ChannelsAdminLogResults) CRC() uint32 {
	return 0xed8af74d
}

type ChannelsChannelParticipant struct {
	Participant ChannelParticipant
	Users       []User
}

func (*ChannelsChannelParticipant) CRC() uint32 {
	return 0xd0d9b163
}

type ChatAdminRights struct {
	ChangeInfo     bool `tl:"flag:0,encoded_in_bitflags"`
	PostMessages   bool `tl:"flag:1,encoded_in_bitflags"`
	EditMessages   bool `tl:"flag:2,encoded_in_bitflags"`
	DeleteMessages bool `tl:"flag:3,encoded_in_bitflags"`
	BanUsers       bool `tl:"flag:4,encoded_in_bitflags"`
	InviteUsers    bool `tl:"flag:5,encoded_in_bitflags"`
	PinMessages    bool `tl:"flag:7,encoded_in_bitflags"`
	AddAdmins      bool `tl:"flag:9,encoded_in_bitflags"`
	Anonymous      bool `tl:"flag:10,encoded_in_bitflags"`
	ManageCall     bool `tl:"flag:11,encoded_in_bitflags"`
}

func (*ChatAdminRights) CRC() uint32 {
	return 0x5fb224d5
}

func (*ChatAdminRights) FlagIndex() int {
	return 0
}

type ChatBannedRights struct {
	ViewMessages bool `tl:"flag:0,encoded_in_bitflags"`
	SendMessages bool `tl:"flag:1,encoded_in_bitflags"`
	SendMedia    bool `tl:"flag:2,encoded_in_bitflags"`
	SendStickers bool `tl:"flag:3,encoded_in_bitflags"`
	SendGifs     bool `tl:"flag:4,encoded_in_bitflags"`
	SendGames    bool `tl:"flag:5,encoded_in_bitflags"`
	SendInline   bool `tl:"flag:6,encoded_in_bitflags"`
	EmbedLinks   bool `tl:"flag:7,encoded_in_bitflags"`
	SendPolls    bool `tl:"flag:8,encoded_in_bitflags"`
	ChangeInfo   bool `tl:"flag:10,encoded_in_bitflags"`
	InviteUsers  bool `tl:"flag:15,encoded_in_bitflags"`
	PinMessages  bool `tl:"flag:17,encoded_in_bitflags"`
	UntilDate    int32
}

func (*ChatBannedRights) CRC() uint32 {
	return 0x9f120418
}

func (*ChatBannedRights) FlagIndex() int {
	return 0
}

type ChatOnlines struct {
	Onlines int32
}

func (*ChatOnlines) CRC() uint32 {
	return 0xf041e250
}

type CodeSettings struct {
	AllowFlashcall bool `tl:"flag:0,encoded_in_bitflags"`
	CurrentNumber  bool `tl:"flag:1,encoded_in_bitflags"`
	AllowAppHash   bool `tl:"flag:4,encoded_in_bitflags"`
}

func (*CodeSettings) CRC() uint32 {
	return 0xdebebe83
}

func (*CodeSettings) FlagIndex() int {
	return 0
}

type Config struct {
	PhonecallsEnabled       bool `tl:"flag:1,encoded_in_bitflags"`
	DefaultP2PContacts      bool `tl:"flag:3,encoded_in_bitflags"`
	PreloadFeaturedStickers bool `tl:"flag:4,encoded_in_bitflags"`
	IgnorePhoneEntities     bool `tl:"flag:5,encoded_in_bitflags"`
	RevokePmInbox           bool `tl:"flag:6,encoded_in_bitflags"`
	BlockedMode             bool `tl:"flag:8,encoded_in_bitflags"`
	PfsEnabled              bool `tl:"flag:13,encoded_in_bitflags"`
	Date                    int32
	Expires                 int32
	TestMode                bool
	ThisDc                  int32
	DcOptions               []*DcOption
	DcTxtDomainName         string
	ChatSizeMax             int32
	MegagroupSizeMax        int32
	ForwardedCountMax       int32
	OnlineUpdatePeriodMs    int32
	OfflineBlurTimeoutMs    int32
	OfflineIdleTimeoutMs    int32
	OnlineCloudTimeoutMs    int32
	NotifyCloudDelayMs      int32
	NotifyDefaultDelayMs    int32
	PushChatPeriodMs        int32
	PushChatLimit           int32
	SavedGifsLimit          int32
	EditTimeLimit           int32
	RevokeTimeLimit         int32
	RevokePmTimeLimit       int32
	RatingEDecay            int32
	StickersRecentLimit     int32
	StickersFavedLimit      int32
	ChannelsReadMediaPeriod int32
	TmpSessions             int32 `tl:"flag:0"`
	PinnedDialogsCountMax   int32
	PinnedInfolderCountMax  int32
	CallReceiveTimeoutMs    int32
	CallRingTimeoutMs       int32
	CallConnectTimeoutMs    int32
	CallPacketTimeoutMs     int32
	MeURLPrefix             string
	AutoupdateURLPrefix     string `tl:"flag:7"`
	GifSearchUsername       string `tl:"flag:9"`
	VenueSearchUsername     string `tl:"flag:10"`
	ImgSearchUsername       string `tl:"flag:11"`
	StaticMapsProvider      string `tl:"flag:12"`
	CaptionLengthMax        int32
	MessageLengthMax        int32
	WebfileDcID             int32
	SuggestedLangCode       string `tl:"flag:2"`
	LangPackVersion         int32  `tl:"flag:2"`
	BaseLangPackVersion     int32  `tl:"flag:2"`
}

func (*Config) CRC() uint32 {
	return 0x330b4067
}

func (*Config) FlagIndex() int {
	return 0
}

type Contact struct {
	UserID int32
	Mutual bool
}

func (*Contact) CRC() uint32 {
	return 0xf911c994
}

type ContactStatus struct {
	UserID int32
	Status UserStatus
}

func (*ContactStatus) CRC() uint32 {
	return 0xd3680c61
}

type ContactsFound struct {
	MyResults []Peer
	Results   []Peer
	Chats     []Chat
	Users     []User
}

func (*ContactsFound) CRC() uint32 {
	return 0xb3134d9d
}

type ContactsImportedContacts struct {
	Imported       []*ImportedContact
	PopularInvites []*PopularContact
	RetryContacts  []int64
	Users          []User
}

func (*ContactsImportedContacts) CRC() uint32 {
	return 0x77d01c3b
}

type ContactsResolvedPeer struct {
	Peer  Peer
	Chats []Chat
	Users []User
}

func (*ContactsResolvedPeer) CRC() uint32 {
	return 0x7f077ad9
}

type DataJson struct {
	Data string
}

func (*DataJson) CRC() uint32 {
	return 0x7d748d04
}

type DcOption struct {
	Ipv6      bool `tl:"flag:0,encoded_in_bitflags"`
	MediaOnly bool `tl:"flag:1,encoded_in_bitflags"`
	TcpoOnly  bool `tl:"flag:2,encoded_in_bitflags"`
	Cdn       bool `tl:"flag:3,encoded_in_bitflags"`
	Static    bool `tl:"flag:4,encoded_in_bitflags"`
	ID        int32
	IpAddress string
	Port      int32
	Secret    []byte `tl:"flag:10"`
}

func (*DcOption) CRC() uint32 {
	return 0x18b7a10d
}

func (*DcOption) FlagIndex() int {
	return 0
}

type DialogFilter struct {
	Contacts        bool `tl:"flag:0,encoded_in_bitflags"`
	NonContacts     bool `tl:"flag:1,encoded_in_bitflags"`
	Groups          bool `tl:"flag:2,encoded_in_bitflags"`
	Broadcasts      bool `tl:"flag:3,encoded_in_bitflags"`
	Bots            bool `tl:"flag:4,encoded_in_bitflags"`
	ExcludeMuted    bool `tl:"flag:11,encoded_in_bitflags"`
	ExcludeRead     bool `tl:"flag:12,encoded_in_bitflags"`
	ExcludeArchived bool `tl:"flag:13,encoded_in_bitflags"`
	ID              int32
	Title           string
	Emoticon        string `tl:"flag:25"`
	PinnedPeers     []InputPeer
	IncludePeers    []InputPeer
	ExcludePeers    []InputPeer
}

func (*DialogFilter) CRC() uint32 {
	return 0x7438f7e8
}

func (*DialogFilter) FlagIndex() int {
	return 0
}

type DialogFilterSuggested struct {
	Filter      *DialogFilter
	Description string
}

func (*DialogFilterSuggested) CRC() uint32 {
	return 0x77744d4a
}

type EmojiKeywordsDifference struct {
	LangCode    string
	FromVersion int32
	Version     int32
	Keywords    []EmojiKeyword
}

func (*EmojiKeywordsDifference) CRC() uint32 {
	return 0x5cc761bd
}

type EmojiLanguage struct {
	LangCode string
}

func (*EmojiLanguage) CRC() uint32 {
	return 0xb3fb5361
}

type EmojiURL struct {
	URL string
}

func (*EmojiURL) CRC() uint32 {
	return 0xa575739d
}

type Error struct {
	Code int32
	Text string
}

func (*Error) CRC() uint32 {
	return 0xc4b9f9bb
}

type ExportedMessageLink struct {
	Link string
	Html string
}

func (*ExportedMessageLink) CRC() uint32 {
	return 0x5dab1af4
}

type FileHash struct {
	Offset int32
	Limit  int32
	Hash   []byte
}

func (*FileHash) CRC() uint32 {
	return 0x6242c773
}

type FileLocationToBeDeprecated struct {
	VolumeID int64
	LocalID  int32
}

func (*FileLocationToBeDeprecated) CRC() uint32 {
	return 0xbc7fc6cd
}

type Folder struct {
	AutofillNewBroadcasts     bool `tl:"flag:0,encoded_in_bitflags"`
	AutofillPublicGroups      bool `tl:"flag:1,encoded_in_bitflags"`
	AutofillNewCorrespondents bool `tl:"flag:2,encoded_in_bitflags"`
	ID                        int32
	Title                     string
	Photo                     ChatPhoto `tl:"flag:3"`
}

func (*Folder) CRC() uint32 {
	return 0xff544e65
}

func (*Folder) FlagIndex() int {
	return 0
}

type FolderPeer struct {
	Peer     Peer
	FolderID int32
}

func (*FolderPeer) CRC() uint32 {
	return 0xe9baa668
}

type Game struct {
	ID          int64
	AccessHash  int64
	ShortName   string
	Title       string
	Description string
	Photo       Photo
	Document    Document `tl:"flag:0"`
}

func (*Game) CRC() uint32 {
	return 0xbdf9653b
}

func (*Game) FlagIndex() int {
	return 0
}

type GlobalPrivacySettings struct {
	ArchiveAndMuteNewNoncontactPeers bool `tl:"flag:0"`
}

func (*GlobalPrivacySettings) CRC() uint32 {
	return 0xbea2f424
}

func (*GlobalPrivacySettings) FlagIndex() int {
	return 0
}

type HelpConfigSimple struct {
	Date    int32
	Expires int32
	Rules   []*AccessPointRule
}

func (*HelpConfigSimple) CRC() uint32 {
	return 0x5a592a6c
}

type HelpCountry struct {
	Hidden       bool `tl:"flag:0,encoded_in_bitflags"`
	Iso2         string
	DefaultName  string
	Name         string `tl:"flag:1"`
	CountryCodes []*HelpCountryCode
}

func (*HelpCountry) CRC() uint32 {
	return 0xc3878e23
}

func (*HelpCountry) FlagIndex() int {
	return 0
}

type HelpCountryCode struct {
	CountryCode string
	Prefixes    []string `tl:"flag:0"`
	Patterns    []string `tl:"flag:1"`
}

func (*HelpCountryCode) CRC() uint32 {
	return 0x4203c5ef
}

func (*HelpCountryCode) FlagIndex() int {
	return 0
}

type HelpInviteText struct {
	Message string
}

func (*HelpInviteText) CRC() uint32 {
	return 0x18cb9f78
}

type HelpRecentMeUrls struct {
	Urls  []RecentMeURL
	Chats []Chat
	Users []User
}

func (*HelpRecentMeUrls) CRC() uint32 {
	return 0xe0310d7
}

type HelpSupport struct {
	PhoneNumber string
	User        User
}

func (*HelpSupport) CRC() uint32 {
	return 0x17c6b5f6
}

type HelpSupportName struct {
	Name string
}

func (*HelpSupportName) CRC() uint32 {
	return 0x8c05f1c9
}

type HelpTermsOfService struct {
	Popup         bool `tl:"flag:0,encoded_in_bitflags"`
	ID            *DataJson
	Text          string
	Entities      []MessageEntity
	MinAgeConfirm int32 `tl:"flag:1"`
}

func (*HelpTermsOfService) CRC() uint32 {
	return 0x780a0310
}

func (*HelpTermsOfService) FlagIndex() int {
	return 0
}

type HighScore struct {
	Pos    int32
	UserID int32
	Score  int32
}

func (*HighScore) CRC() uint32 {
	return 0x58fffcd0
}

type ImportedContact struct {
	UserID   int32
	ClientID int64
}

func (*ImportedContact) CRC() uint32 {
	return 0xd0028438
}

type InlineBotSwitchPm struct {
	Text       string
	StartParam string
}

func (*InlineBotSwitchPm) CRC() uint32 {
	return 0x3c20629f
}

type InputAppEvent struct {
	Time float64
	Type string
	Peer int64
	Data JsonValue
}

func (*InputAppEvent) CRC() uint32 {
	return 0x1d1b1245
}

type InputBotInlineMessageID struct {
	DcID       int32
	ID         int64
	AccessHash int64
}

func (*InputBotInlineMessageID) CRC() uint32 {
	return 0x890c3d89
}

type InputClientProxy struct {
	Address string
	Port    int32
}

func (*InputClientProxy) CRC() uint32 {
	return 0x75588b3f
}

type InputEncryptedChat struct {
	ChatID     int32
	AccessHash int64
}

func (*InputEncryptedChat) CRC() uint32 {
	return 0xf141b5e1
}

type InputFolderPeer struct {
	Peer     InputPeer
	FolderID int32
}

func (*InputFolderPeer) CRC() uint32 {
	return 0xfbd2c296
}

type InputPeerNotifySettings struct {
	ShowPreviews bool   `tl:"flag:0"`
	Silent       bool   `tl:"flag:1"`
	MuteUntil    int32  `tl:"flag:2"`
	Sound        string `tl:"flag:3"`
}

func (*InputPeerNotifySettings) CRC() uint32 {
	return 0x9c3d198e
}

func (*InputPeerNotifySettings) FlagIndex() int {
	return 0
}

type InputPhoneCall struct {
	ID         int64
	AccessHash int64
}

func (*InputPhoneCall) CRC() uint32 {
	return 0x1e36fded
}

// Phone contact. The client_id is just an arbitrary contact ID: it should be set, for example, to an incremental number when using contacts.importContacts, in order to retry importing only the contacts that weren't imported successfully.
type InputPhoneContact struct {
	ClientID  int64  // User identifier on the client
	Phone     string // Phone number
	FirstName string // Contact's first name
	LastName  string // Contact's last name
}

func (*InputPhoneContact) CRC() uint32 {
	return 0xf392b7f4
}

type InputSecureValue struct {
	Type        SecureValueType
	Data        *SecureData       `tl:"flag:0"`
	FrontSide   InputSecureFile   `tl:"flag:1"`
	ReverseSide InputSecureFile   `tl:"flag:2"`
	Selfie      InputSecureFile   `tl:"flag:3"`
	Translation []InputSecureFile `tl:"flag:6"`
	Files       []InputSecureFile `tl:"flag:4"`
	PlainData   SecurePlainData   `tl:"flag:5"`
}

func (*InputSecureValue) CRC() uint32 {
	return 0xdb21d0a7
}

func (*InputSecureValue) FlagIndex() int {
	return 0
}

type InputSingleMedia struct {
	Media    InputMedia
	RandomID int64
	Message  string
	Entities []MessageEntity `tl:"flag:0"`
}

func (*InputSingleMedia) CRC() uint32 {
	return 0x1cc6e91f
}

func (*InputSingleMedia) FlagIndex() int {
	return 0
}

type InputStickerSetItem struct {
	Document   InputDocument
	Emoji      string
	MaskCoords *MaskCoords `tl:"flag:0"`
}

func (*InputStickerSetItem) CRC() uint32 {
	return 0xffa0a496
}

func (*InputStickerSetItem) FlagIndex() int {
	return 0
}

type InputThemeSettings struct {
	BaseTheme          BaseTheme
	AccentColor        int32
	MessageTopColor    int32              `tl:"flag:0"`
	MessageBottomColor int32              `tl:"flag:0"`
	Wallpaper          InputWallPaper     `tl:"flag:1"`
	WallpaperSettings  *WallPaperSettings `tl:"flag:1"`
}

func (*InputThemeSettings) CRC() uint32 {
	return 0xbd507cd1
}

func (*InputThemeSettings) FlagIndex() int {
	return 0
}

type InputWebDocument struct {
	URL        string
	Size       int32
	MimeType   string
	Attributes []DocumentAttribute
}

func (*InputWebDocument) CRC() uint32 {
	return 0x9bed434d
}

type Invoice struct {
	Test                     bool `tl:"flag:0,encoded_in_bitflags"`
	NameRequested            bool `tl:"flag:1,encoded_in_bitflags"`
	PhoneRequested           bool `tl:"flag:2,encoded_in_bitflags"`
	EmailRequested           bool `tl:"flag:3,encoded_in_bitflags"`
	ShippingAddressRequested bool `tl:"flag:4,encoded_in_bitflags"`
	Flexible                 bool `tl:"flag:5,encoded_in_bitflags"`
	PhoneToProvider          bool `tl:"flag:6,encoded_in_bitflags"`
	EmailToProvider          bool `tl:"flag:7,encoded_in_bitflags"`
	Currency                 string
	Prices                   []*LabeledPrice
}

func (*Invoice) CRC() uint32 {
	return 0xc30aa358
}

func (*Invoice) FlagIndex() int {
	return 0
}

type JsonObjectValue struct {
	Key   string
	Value JsonValue
}

func (*JsonObjectValue) CRC() uint32 {
	return 0xc0de1bd9
}

type KeyboardButtonRow struct {
	Buttons []KeyboardButton
}

func (*KeyboardButtonRow) CRC() uint32 {
	return 0x77608b83
}

type LabeledPrice struct {
	Label  string
	Amount int64
}

func (*LabeledPrice) CRC() uint32 {
	return 0xcb296bf8
}

type LangPackDifference struct {
	LangCode    string
	FromVersion int32
	Version     int32
	Strings     []LangPackString
}

func (*LangPackDifference) CRC() uint32 {
	return 0xf385c1f6
}

type LangPackLanguage struct {
	Official        bool `tl:"flag:0,encoded_in_bitflags"`
	Rtl             bool `tl:"flag:2,encoded_in_bitflags"`
	Beta            bool `tl:"flag:3,encoded_in_bitflags"`
	Name            string
	NativeName      string
	LangCode        string
	BaseLangCode    string `tl:"flag:1"`
	PluralCode      string
	StringsCount    int32
	TranslatedCount int32
	TranslationsURL string
}

func (*LangPackLanguage) CRC() uint32 {
	return 0xeeca5ce3
}

func (*LangPackLanguage) FlagIndex() int {
	return 0
}

type MaskCoords struct {
	N    int32
	X    float64
	Y    float64
	Zoom float64
}

func (*MaskCoords) CRC() uint32 {
	return 0xaed6dbb2
}

type MessageFwdHeader struct {
	FromID         Peer   `tl:"flag:0"`
	FromName       string `tl:"flag:5"`
	Date           int32
	ChannelPost    int32  `tl:"flag:2"`
	PostAuthor     string `tl:"flag:3"`
	SavedFromPeer  Peer   `tl:"flag:4"`
	SavedFromMsgID int32  `tl:"flag:4"`
	PsaType        string `tl:"flag:6"`
}

func (*MessageFwdHeader) CRC() uint32 {
	return 0x5f777dce
}

func (*MessageFwdHeader) FlagIndex() int {
	return 0
}

type MessageInteractionCounters struct {
	MsgID    int32
	Views    int32
	Forwards int32
}

func (*MessageInteractionCounters) CRC() uint32 {
	return 0xad4fc9bd
}

type MessageRange struct {
	MinID int32
	MaxID int32
}

func (*MessageRange) CRC() uint32 {
	return 0xae30253
}

type MessageReplies struct {
	Comments       bool `tl:"flag:0,encoded_in_bitflags"`
	Replies        int32
	RepliesPts     int32
	RecentRepliers []Peer `tl:"flag:1"`
	ChannelID      int32  `tl:"flag:0"`
	MaxID          int32  `tl:"flag:2"`
	ReadMaxID      int32  `tl:"flag:3"`
}

func (*MessageReplies) CRC() uint32 {
	return 0x4128faac
}

func (*MessageReplies) FlagIndex() int {
	return 0
}

type MessageReplyHeader struct {
	ReplyToMsgID  int32
	ReplyToPeerID Peer  `tl:"flag:0"`
	ReplyToTopID  int32 `tl:"flag:1"`
}

func (*MessageReplyHeader) CRC() uint32 {
	return 0xa6d57763
}

func (*MessageReplyHeader) FlagIndex() int {
	return 0
}

type MessageViews struct {
	Views    int32           `tl:"flag:0"`
	Forwards int32           `tl:"flag:1"`
	Replies  *MessageReplies `tl:"flag:2"`
}

func (*MessageViews) CRC() uint32 {
	return 0x455b853d
}

func (*MessageViews) FlagIndex() int {
	return 0
}

type MessagesAffectedHistory struct {
	Pts      int32
	PtsCount int32
	Offset   int32
}

func (*MessagesAffectedHistory) CRC() uint32 {
	return 0xb45c69d1
}

type MessagesAffectedMessages struct {
	Pts      int32
	PtsCount int32
}

func (*MessagesAffectedMessages) CRC() uint32 {
	return 0x84d19185
}

type MessagesArchivedStickers struct {
	Count int32
	Sets  []StickerSetCovered
}

func (*MessagesArchivedStickers) CRC() uint32 {
	return 0x4fcba9c8
}

type MessagesBotCallbackAnswer struct {
	Alert     bool   `tl:"flag:1,encoded_in_bitflags"`
	HasURL    bool   `tl:"flag:3,encoded_in_bitflags"`
	NativeUi  bool   `tl:"flag:4,encoded_in_bitflags"`
	Message   string `tl:"flag:0"`
	URL       string `tl:"flag:2"`
	CacheTime int32
}

func (*MessagesBotCallbackAnswer) CRC() uint32 {
	return 0x36585ea4
}

func (*MessagesBotCallbackAnswer) FlagIndex() int {
	return 0
}

type MessagesBotResults struct {
	Gallery    bool `tl:"flag:0,encoded_in_bitflags"`
	QueryID    int64
	NextOffset string             `tl:"flag:1"`
	SwitchPm   *InlineBotSwitchPm `tl:"flag:2"`
	Results    []BotInlineResult
	CacheTime  int32
	Users      []User
}

func (*MessagesBotResults) CRC() uint32 {
	return 0x947ca848
}

func (*MessagesBotResults) FlagIndex() int {
	return 0
}

type MessagesChatFull struct {
	FullChat ChatFull
	Chats    []Chat
	Users    []User
}

func (*MessagesChatFull) CRC() uint32 {
	return 0xe5d7d19c
}

type MessagesDiscussionMessage struct {
	Messages        []Message
	MaxID           int32 `tl:"flag:0"`
	ReadInboxMaxID  int32 `tl:"flag:1"`
	ReadOutboxMaxID int32 `tl:"flag:2"`
	Chats           []Chat
	Users           []User
}

func (*MessagesDiscussionMessage) CRC() uint32 {
	return 0xf5dd8f9d
}

func (*MessagesDiscussionMessage) FlagIndex() int {
	return 0
}

type MessagesHighScores struct {
	Scores []*HighScore
	Users  []User
}

func (*MessagesHighScores) CRC() uint32 {
	return 0x9a3bfd99
}

type MessagesInactiveChats struct {
	Dates []int32
	Chats []Chat
	Users []User
}

func (*MessagesInactiveChats) CRC() uint32 {
	return 0xa927fec5
}

type MessagesMessageEditData struct {
	Caption bool `tl:"flag:0,encoded_in_bitflags"`
}

func (*MessagesMessageEditData) CRC() uint32 {
	return 0x26b5dde6
}

func (*MessagesMessageEditData) FlagIndex() int {
	return 0
}

type MessagesMessageViews struct {
	Views []*MessageViews
	Chats []Chat
	Users []User
}

func (*MessagesMessageViews) CRC() uint32 {
	return 0xb6c4f543
}

type MessagesPeerDialogs struct {
	Dialogs  []Dialog
	Messages []Message
	Chats    []Chat
	Users    []User
	State    *UpdatesState
}

func (*MessagesPeerDialogs) CRC() uint32 {
	return 0x3371c354
}

type MessagesSearchCounter struct {
	Inexact bool `tl:"flag:1,encoded_in_bitflags"`
	Filter  MessagesFilter
	Count   int32
}

func (*MessagesSearchCounter) CRC() uint32 {
	return 0xe844ebff
}

func (*MessagesSearchCounter) FlagIndex() int {
	return 0
}

type MessagesStickerSet struct {
	Set       *StickerSet
	Packs     []*StickerPack
	Documents []Document
}

func (*MessagesStickerSet) CRC() uint32 {
	return 0xb60a24a6
}

type MessagesVotesList struct {
	Count      int32
	Votes      []MessageUserVote
	Users      []User
	NextOffset string `tl:"flag:0"`
}

func (*MessagesVotesList) CRC() uint32 {
	return 0x823f649
}

func (*MessagesVotesList) FlagIndex() int {
	return 0
}

type NearestDc struct {
	Country   string
	ThisDc    int32
	NearestDc int32
}

func (*NearestDc) CRC() uint32 {
	return 0x8e1a1775
}

type Page struct {
	Part      bool `tl:"flag:0,encoded_in_bitflags"`
	Rtl       bool `tl:"flag:1,encoded_in_bitflags"`
	V2        bool `tl:"flag:2,encoded_in_bitflags"`
	URL       string
	Blocks    []PageBlock
	Photos    []Photo
	Documents []Document
	Views     int32 `tl:"flag:3"`
}

func (*Page) CRC() uint32 {
	return 0x98657f0d
}

func (*Page) FlagIndex() int {
	return 0
}

type PageCaption struct {
	Text   RichText
	Credit RichText
}

func (*PageCaption) CRC() uint32 {
	return 0x6f747657
}

type PageRelatedArticle struct {
	URL           string
	WebpageID     int64
	Title         string `tl:"flag:0"`
	Description   string `tl:"flag:1"`
	PhotoID       int64  `tl:"flag:2"`
	Author        string `tl:"flag:3"`
	PublishedDate int32  `tl:"flag:4"`
}

func (*PageRelatedArticle) CRC() uint32 {
	return 0xb390dc08
}

func (*PageRelatedArticle) FlagIndex() int {
	return 0
}

type PageTableCell struct {
	Header       bool     `tl:"flag:0,encoded_in_bitflags"`
	AlignCenter  bool     `tl:"flag:3,encoded_in_bitflags"`
	AlignRight   bool     `tl:"flag:4,encoded_in_bitflags"`
	ValignMiddle bool     `tl:"flag:5,encoded_in_bitflags"`
	ValignBottom bool     `tl:"flag:6,encoded_in_bitflags"`
	Text         RichText `tl:"flag:7"`
	Colspan      int32    `tl:"flag:1"`
	Rowspan      int32    `tl:"flag:2"`
}

func (*PageTableCell) CRC() uint32 {
	return 0x34566b6a
}

func (*PageTableCell) FlagIndex() int {
	return 0
}

type PageTableRow struct {
	Cells []*PageTableCell
}

func (*PageTableRow) CRC() uint32 {
	return 0xe0c0c5e5
}

type PaymentCharge struct {
	ID               string
	ProviderChargeID string
}

func (*PaymentCharge) CRC() uint32 {
	return 0xea02c27e
}

type PaymentRequestedInfo struct {
	Name            string       `tl:"flag:0"`
	Phone           string       `tl:"flag:1"`
	Email           string       `tl:"flag:2"`
	ShippingAddress *PostAddress `tl:"flag:3"`
}

func (*PaymentRequestedInfo) CRC() uint32 {
	return 0x909c3f94
}

func (*PaymentRequestedInfo) FlagIndex() int {
	return 0
}

type PaymentSavedCredentialsCard struct {
	ID    string
	Title string
}

func (*PaymentSavedCredentialsCard) CRC() uint32 {
	return 0xcdc27a1f
}

type PaymentsBankCardData struct {
	Title    string
	OpenUrls []*BankCardOpenURL
}

func (*PaymentsBankCardData) CRC() uint32 {
	return 0x3e24e573
}

// Payment form
type PaymentsPaymentForm struct {
	CanSaveCredentials bool                         `tl:"flag:2,encoded_in_bitflags"` // Whether the user can choose to save credentials.
	PasswordMissing    bool                         `tl:"flag:3,encoded_in_bitflags"` // Indicates that the user can save payment credentials, but only after setting up a 2FA password (currently the account doesn't have a 2FA password)
	BotID              int32                        // Bot ID
	Invoice            *Invoice                     // Invoice
	ProviderID         int32                        // Payment provider ID.
	URL                string                       // Payment form URL
	NativeProvider     string                       `tl:"flag:4"` // Payment provider name.One of the following:- stripe
	NativeParams       *DataJson                    `tl:"flag:4"` // Contains information about the payment provider, if available, to support it natively without the need for opening the URL.A JSON object that can contain the following fields:- publishable_key: Stripe API publishable key- apple_pay_merchant_id: Apple Pay merchant ID- android_pay_public_key: Android Pay public key- android_pay_bgcolor: Android Pay form background color- android_pay_inverse: Whether to use the dark theme in the Android Pay form- need_country: True, if the user country must be provided,- need_zip: True, if the user ZIP/postal code must be provided,- need_cardholder_name: True, if the cardholder name must be provided
	SavedInfo          *PaymentRequestedInfo        `tl:"flag:0"` // Saved server-side order information
	SavedCredentials   *PaymentSavedCredentialsCard `tl:"flag:1"` // Contains information about saved card credentials
	Users              []User                       // Users
}

func (*PaymentsPaymentForm) CRC() uint32 {
	return 0x3f56aea3
}

func (*PaymentsPaymentForm) FlagIndex() int {
	return 0
}

type PaymentsPaymentReceipt struct {
	Date             int32
	BotID            int32
	Invoice          *Invoice
	ProviderID       int32
	Info             *PaymentRequestedInfo `tl:"flag:0"`
	Shipping         *ShippingOption       `tl:"flag:1"`
	Currency         string
	TotalAmount      int64
	CredentialsTitle string
	Users            []User
}

func (*PaymentsPaymentReceipt) CRC() uint32 {
	return 0x500911e1
}

func (*PaymentsPaymentReceipt) FlagIndex() int {
	return 0
}

type PaymentsSavedInfo struct {
	HasSavedCredentials bool                  `tl:"flag:1,encoded_in_bitflags"`
	SavedInfo           *PaymentRequestedInfo `tl:"flag:0"`
}

func (*PaymentsSavedInfo) CRC() uint32 {
	return 0xfb8fe43c
}

func (*PaymentsSavedInfo) FlagIndex() int {
	return 0
}

type PaymentsValidatedRequestedInfo struct {
	ID              string            `tl:"flag:0"`
	ShippingOptions []*ShippingOption `tl:"flag:1"`
}

func (*PaymentsValidatedRequestedInfo) CRC() uint32 {
	return 0xd1451883
}

func (*PaymentsValidatedRequestedInfo) FlagIndex() int {
	return 0
}

type PeerBlocked struct {
	PeerID Peer
	Date   int32
}

func (*PeerBlocked) CRC() uint32 {
	return 0xe8fd8014
}

type PeerNotifySettings struct {
	ShowPreviews bool   `tl:"flag:0"`
	Silent       bool   `tl:"flag:1"`
	MuteUntil    int32  `tl:"flag:2"`
	Sound        string `tl:"flag:3"`
}

func (*PeerNotifySettings) CRC() uint32 {
	return 0xaf509d20
}

func (*PeerNotifySettings) FlagIndex() int {
	return 0
}

type PeerSettings struct {
	ReportSpam            bool  `tl:"flag:0,encoded_in_bitflags"`
	AddContact            bool  `tl:"flag:1,encoded_in_bitflags"`
	BlockContact          bool  `tl:"flag:2,encoded_in_bitflags"`
	ShareContact          bool  `tl:"flag:3,encoded_in_bitflags"`
	NeedContactsException bool  `tl:"flag:4,encoded_in_bitflags"`
	ReportGeo             bool  `tl:"flag:5,encoded_in_bitflags"`
	Autoarchived          bool  `tl:"flag:7,encoded_in_bitflags"`
	GeoDistance           int32 `tl:"flag:6"`
}

func (*PeerSettings) CRC() uint32 {
	return 0x733f2961
}

func (*PeerSettings) FlagIndex() int {
	return 0
}

type PhonePhoneCall struct {
	PhoneCall PhoneCall
	Users     []User
}

func (*PhonePhoneCall) CRC() uint32 {
	return 0xec82e140
}

type PhoneCallProtocol struct {
	UdpP2P          bool `tl:"flag:0,encoded_in_bitflags"`
	UdpReflector    bool `tl:"flag:1,encoded_in_bitflags"`
	MinLayer        int32
	MaxLayer        int32
	LibraryVersions []string
}

func (*PhoneCallProtocol) CRC() uint32 {
	return 0xfc878fc8
}

func (*PhoneCallProtocol) FlagIndex() int {
	return 0
}

type PhotosPhoto struct {
	Photo Photo
	Users []User
}

func (*PhotosPhoto) CRC() uint32 {
	return 0x20212ca8
}

type Poll struct {
	ID             int64
	Closed         bool `tl:"flag:0,encoded_in_bitflags"`
	PublicVoters   bool `tl:"flag:1,encoded_in_bitflags"`
	MultipleChoice bool `tl:"flag:2,encoded_in_bitflags"`
	Quiz           bool `tl:"flag:3,encoded_in_bitflags"`
	Question       string
	Answers        []*PollAnswer
	ClosePeriod    int32 `tl:"flag:4"`
	CloseDate      int32 `tl:"flag:5"`
}

func (*Poll) CRC() uint32 {
	return 0x86e18161
}

func (*Poll) FlagIndex() int {
	return 1
}

type PollAnswer struct {
	Text   string
	Option []byte
}

func (*PollAnswer) CRC() uint32 {
	return 0x6ca9c2e9
}

type PollAnswerVoters struct {
	Chosen  bool `tl:"flag:0,encoded_in_bitflags"`
	Correct bool `tl:"flag:1,encoded_in_bitflags"`
	Option  []byte
	Voters  int32
}

func (*PollAnswerVoters) CRC() uint32 {
	return 0x3b6ddad2
}

func (*PollAnswerVoters) FlagIndex() int {
	return 0
}

type PollResults struct {
	Min              bool                `tl:"flag:0,encoded_in_bitflags"`
	Results          []*PollAnswerVoters `tl:"flag:1"`
	TotalVoters      int32               `tl:"flag:2"`
	RecentVoters     []int32             `tl:"flag:3"`
	Solution         string              `tl:"flag:4"`
	SolutionEntities []MessageEntity     `tl:"flag:4"`
}

func (*PollResults) CRC() uint32 {
	return 0xbadcc1a3
}

func (*PollResults) FlagIndex() int {
	return 0
}

type PopularContact struct {
	ClientID  int64
	Importers int32
}

func (*PopularContact) CRC() uint32 {
	return 0x5ce14175
}

type PostAddress struct {
	StreetLine1 string
	StreetLine2 string
	City        string
	State       string
	CountryIso2 string
	PostCode    string
}

func (*PostAddress) CRC() uint32 {
	return 0x1e8caaeb
}

type ReceivedNotifyMessage struct {
	ID    int32
	Flags int32
}

func (*ReceivedNotifyMessage) CRC() uint32 {
	return 0xa384b779
}

type RestrictionReason struct {
	Platform string
	Reason   string
	Text     string
}

func (*RestrictionReason) CRC() uint32 {
	return 0xd072acb4
}

type SavedPhoneContact struct {
	Phone     string
	FirstName string
	LastName  string
	Date      int32
}

func (*SavedPhoneContact) CRC() uint32 {
	return 0x1142bd56
}

type SecureCredentialsEncrypted struct {
	Data   []byte
	Hash   []byte
	Secret []byte
}

func (*SecureCredentialsEncrypted) CRC() uint32 {
	return 0x33f0ea47
}

type SecureData struct {
	Data     []byte
	DataHash []byte
	Secret   []byte
}

func (*SecureData) CRC() uint32 {
	return 0x8aeabec3
}

type SecureSecretSettings struct {
	SecureAlgo     SecurePasswordKdfAlgo
	SecureSecret   []byte
	SecureSecretID int64
}

func (*SecureSecretSettings) CRC() uint32 {
	return 0x1527bcac
}

type SecureValue struct {
	Type        SecureValueType
	Data        *SecureData     `tl:"flag:0"`
	FrontSide   SecureFile      `tl:"flag:1"`
	ReverseSide SecureFile      `tl:"flag:2"`
	Selfie      SecureFile      `tl:"flag:3"`
	Translation []SecureFile    `tl:"flag:6"`
	Files       []SecureFile    `tl:"flag:4"`
	PlainData   SecurePlainData `tl:"flag:5"`
	Hash        []byte
}

func (*SecureValue) CRC() uint32 {
	return 0x187fa0ca
}

func (*SecureValue) FlagIndex() int {
	return 0
}

type SecureValueHash struct {
	Type SecureValueType
	Hash []byte
}

func (*SecureValueHash) CRC() uint32 {
	return 0xed1ecdb0
}

type ShippingOption struct {
	ID     string
	Title  string
	Prices []*LabeledPrice
}

func (*ShippingOption) CRC() uint32 {
	return 0xb6213cdf
}

type StatsBroadcastStats struct {
	Period                    *StatsDateRangeDays
	Followers                 *StatsAbsValueAndPrev
	ViewsPerPost              *StatsAbsValueAndPrev
	SharesPerPost             *StatsAbsValueAndPrev
	EnabledNotifications      *StatsPercentValue
	GrowthGraph               StatsGraph
	FollowersGraph            StatsGraph
	MuteGraph                 StatsGraph
	TopHoursGraph             StatsGraph
	InteractionsGraph         StatsGraph
	IvInteractionsGraph       StatsGraph
	ViewsBySourceGraph        StatsGraph
	NewFollowersBySourceGraph StatsGraph
	LanguagesGraph            StatsGraph
	RecentMessageInteractions []*MessageInteractionCounters
}

func (*StatsBroadcastStats) CRC() uint32 {
	return 0xbdf78394
}

type StatsMegagroupStats struct {
	Period                  *StatsDateRangeDays
	Members                 *StatsAbsValueAndPrev
	Messages                *StatsAbsValueAndPrev
	Viewers                 *StatsAbsValueAndPrev
	Posters                 *StatsAbsValueAndPrev
	GrowthGraph             StatsGraph
	MembersGraph            StatsGraph
	NewMembersBySourceGraph StatsGraph
	LanguagesGraph          StatsGraph
	MessagesGraph           StatsGraph
	ActionsGraph            StatsGraph
	TopHoursGraph           StatsGraph
	WeekdaysGraph           StatsGraph
	TopPosters              []*StatsGroupTopPoster
	TopAdmins               []*StatsGroupTopAdmin
	TopInviters             []*StatsGroupTopInviter
	Users                   []User
}

func (*StatsMegagroupStats) CRC() uint32 {
	return 0xef7ff916
}

type StatsMessageStats struct {
	ViewsGraph StatsGraph
}

func (*StatsMessageStats) CRC() uint32 {
	return 0x8999f295
}

type StatsAbsValueAndPrev struct {
	Current  float64
	Previous float64
}

func (*StatsAbsValueAndPrev) CRC() uint32 {
	return 0xcb43acde
}

type StatsDateRangeDays struct {
	MinDate int32
	MaxDate int32
}

func (*StatsDateRangeDays) CRC() uint32 {
	return 0xb637edaf
}

type StatsGroupTopAdmin struct {
	UserID  int32
	Deleted int32
	Kicked  int32
	Banned  int32
}

func (*StatsGroupTopAdmin) CRC() uint32 {
	return 0x6014f412
}

type StatsGroupTopInviter struct {
	UserID      int32
	Invitations int32
}

func (*StatsGroupTopInviter) CRC() uint32 {
	return 0x31962a4c
}

type StatsGroupTopPoster struct {
	UserID   int32
	Messages int32
	AvgChars int32
}

func (*StatsGroupTopPoster) CRC() uint32 {
	return 0x18f3d0f7
}

type StatsPercentValue struct {
	Part  float64
	Total float64
}

func (*StatsPercentValue) CRC() uint32 {
	return 0xcbce2fe0
}

type StatsURL struct {
	URL string
}

func (*StatsURL) CRC() uint32 {
	return 0x47a971e0
}

type StickerPack struct {
	Emoticon  string
	Documents []int64
}

func (*StickerPack) CRC() uint32 {
	return 0x12b299d4
}

type StickerSet struct {
	Archived      bool  `tl:"flag:1,encoded_in_bitflags"`
	Official      bool  `tl:"flag:2,encoded_in_bitflags"`
	Masks         bool  `tl:"flag:3,encoded_in_bitflags"`
	Animated      bool  `tl:"flag:5,encoded_in_bitflags"`
	InstalledDate int32 `tl:"flag:0"`
	ID            int64
	AccessHash    int64
	Title         string
	ShortName     string
	Thumb         PhotoSize `tl:"flag:4"`
	ThumbDcID     int32     `tl:"flag:4"`
	Count         int32
	Hash          int32
}

func (*StickerSet) CRC() uint32 {
	return 0xeeb46f27
}

func (*StickerSet) FlagIndex() int {
	return 0
}

type Theme struct {
	Creator       bool `tl:"flag:0,encoded_in_bitflags"`
	Default       bool `tl:"flag:1,encoded_in_bitflags"`
	ID            int64
	AccessHash    int64
	Slug          string
	Title         string
	Document      Document       `tl:"flag:2"`
	Settings      *ThemeSettings `tl:"flag:3"`
	InstallsCount int32
}

func (*Theme) CRC() uint32 {
	return 0x28f1114
}

func (*Theme) FlagIndex() int {
	return 0
}

type ThemeSettings struct {
	BaseTheme          BaseTheme
	AccentColor        int32
	MessageTopColor    int32     `tl:"flag:0"`
	MessageBottomColor int32     `tl:"flag:0"`
	Wallpaper          WallPaper `tl:"flag:1"`
}

func (*ThemeSettings) CRC() uint32 {
	return 0x9c14984a
}

func (*ThemeSettings) FlagIndex() int {
	return 0
}

type TopPeer struct {
	Peer   Peer
	Rating float64
}

func (*TopPeer) CRC() uint32 {
	return 0xedcdc05b
}

type TopPeerCategoryPeers struct {
	Category TopPeerCategory
	Count    int32
	Peers    []*TopPeer
}

func (*TopPeerCategoryPeers) CRC() uint32 {
	return 0xfb834291
}

type UpdatesState struct {
	Pts         int32
	Qts         int32
	Date        int32
	Seq         int32
	UnreadCount int32
}

func (*UpdatesState) CRC() uint32 {
	return 0xa56c2a3e
}

type UploadWebFile struct {
	Size     int32
	MimeType string
	FileType StorageFileType
	Mtime    int32
	Bytes    []byte
}

func (*UploadWebFile) CRC() uint32 {
	return 0x21e753bc
}

type UserFull struct {
	Blocked             bool `tl:"flag:0,encoded_in_bitflags"`
	PhoneCallsAvailable bool `tl:"flag:4,encoded_in_bitflags"`
	PhoneCallsPrivate   bool `tl:"flag:5,encoded_in_bitflags"`
	CanPinMessage       bool `tl:"flag:7,encoded_in_bitflags"`
	HasScheduled        bool `tl:"flag:12,encoded_in_bitflags"`
	VideoCallsAvailable bool `tl:"flag:13,encoded_in_bitflags"`
	User                User
	About               string `tl:"flag:1"`
	Settings            *PeerSettings
	ProfilePhoto        Photo `tl:"flag:2"`
	NotifySettings      *PeerNotifySettings
	BotInfo             *BotInfo `tl:"flag:3"`
	PinnedMsgID         int32    `tl:"flag:6"`
	CommonChatsCount    int32
	FolderID            int32 `tl:"flag:11"`
}

func (*UserFull) CRC() uint32 {
	return 0xedf17c12
}

func (*UserFull) FlagIndex() int {
	return 0
}

type VideoSize struct {
	Type         string
	Location     *FileLocationToBeDeprecated
	W            int32
	H            int32
	Size         int32
	VideoStartTs float64 `tl:"flag:0"`
}

func (*VideoSize) CRC() uint32 {
	return 0xe831c556
}

func (*VideoSize) FlagIndex() int {
	return 0
}

type WallPaperSettings struct {
	Blur                  bool  `tl:"flag:1,encoded_in_bitflags"`
	Motion                bool  `tl:"flag:2,encoded_in_bitflags"`
	BackgroundColor       int32 `tl:"flag:0"`
	SecondBackgroundColor int32 `tl:"flag:4"`
	Intensity             int32 `tl:"flag:3"`
	Rotation              int32 `tl:"flag:4"`
}

func (*WallPaperSettings) CRC() uint32 {
	return 0x5086cf8
}

func (*WallPaperSettings) FlagIndex() int {
	return 0
}

type WebAuthorization struct {
	Hash        int64
	BotID       int32
	Domain      string
	Browser     string
	Platform    string
	DateCreated int32
	DateActive  int32
	Ip          string
	Region      string
}

func (*WebAuthorization) CRC() uint32 {
	return 0xcac943f2
}

type WebPageAttributeTheme struct {
	Documents []Document     `tl:"flag:0"`
	Settings  *ThemeSettings `tl:"flag:1"`
}

func (*WebPageAttributeTheme) CRC() uint32 {
	return 0x54b56617
}

func (*WebPageAttributeTheme) FlagIndex() int {
	return 0
}
